HDU 4283 You Are the One——区间DP

传送门

Problem Description
  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?

Input
  The first line contains a single integer T, the number of test cases. For each case, the first line is n (0 < n <= 100)
  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)

Output
  For each test case, output the least summary of unhappiness .
Sample Input

2
  
5
1
2
3
4
5

5
5
4
3
2
2

Sample Output

Case #1: 20
Case #2: 24

题意: 一组人,每个人都要自己的愤怒值Di,排在队伍中第k个人产生的愤怒值为(k-1)*Di。现在可以将他们其中的一些人送进小黑屋,先进小黑屋的人最后出来(其实就是栈),以此来改变队伍的原有排序,使得队伍最后产生的总愤怒值最小。
题解: 当队伍小到只有两个人的时候,只要考虑两个人谁先谁后,两种情况的总愤怒值比较一下选取较小值即可。当队伍人数扩大时(队伍从小变大,因此其中的子队伍,应该时已经获得最小的总愤怒值),我们要考虑队伍中的第一个人,安排在第几位。设dp[i][j]为第i个人到第j个人能达到的最小总愤怒值。

#include<iostream>
#include<algorithm>
using namespace std;
const int N = 110;
const int inf = 0x3f3f3f3f;

int t, n, cnt;
int num[N], sum[N];
int dp[N][N];
int main(){
    scanf("%d", &t);
    while(t--){
        scanf("%d", &n);
        for (int i = 1; i <= n; i++){
            scanf("%d", num + i);
            sum[i] = sum[i - 1] + num[i];
        }
        for (int len = 1; len < n; len++){
            for (int l = 1; l + len <= n; l++){
                int r = l + len;
                dp[l][r] = inf;
                for (int k = l; k <= r; k++)
                    dp[l][r] = min(dp[l][r], num[l] * (k - l) + dp[l + 1][k] + dp[k + 1][r] + (sum[r] - sum[k]) * (k - l + 1));
            }
        }
        printf("Case #%d: %d\n", ++cnt, dp[1][n]);
    }
    return 0;
}
  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值